/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998-2015 Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * tempura library defining various TAM constructs
 *
 */

define chan(X) = { list(X, 3) and stable(struct(X)) and
                   X[0] defaults 0 and X[1] defaults 0}.

define wtr(C) = { C[0] }.

define wtw(C) = { C[1] }.

define val(C) = { C[2] }.

define comr(C,X) = { X = C[2] and wtr(C)=1  }.

define comw(C,X) = {  wtw(C)=1 and C[2] = X }.

define rdc(C,X) = { wtr(C)=1 and
  if wtr(C)=1 and wtw(C)=1 then comr(C,X)
  else { {wtr(C)=1 and wtw(C)=0 and stable(C)};skip;comr(C,X) }
}.

define ready(C) = {
    wtw(C)=1 
}.

define wrc(C,X) = { wtw(C)=1 and
  if wtr(C)=1 and wtw(C)=1 then comw(C,X)
  else { {wtr(C)=0 and wtw(C)=1 and stable(C)};skip;comw(C,X) }
}.

define trdc(C,d,X) = {
  rdc(C,X) and len(d)
}.

define twrc(C,d,X) = {
  wrc(C,X) and len(d)
}.


define shunt(X) = { list(X, 2) and stable(struct(X)) }.

define stmp(S) = { S[0] }.

define rds(S) = { S[1] }. 

define wrs(S,X) = { 
  skip and S[0] := S[0] +1 and S[1] := X 
}.

define swrs(S,X) = { 
   S[0] := S[0] +1 and S[1] := X 
}.

define twrs(S,d,X) = {
 len(d-1) ; wrs(S,X)
}.

define delay(d) = { len(d) }.

